# -*- coding: utf-8 -*-
"""
$Id: TemplatesProvider.py,v 1.2 2005/09/14 13:29:25 encolpe Exp $
"""

__author__  = ''
__docformat__ = 'restructuredtext'


# Python imports
from AccessControl import ClassSecurityInfo

# CMF imports
from Products.CMFCore  import CMFCorePermissions
from Products.CMFCore.utils import getToolByName

# Archetypes imports
from Products.Archetypes.public import *

# Products imports
from Products.PloneSubscription.config import PROJECTNAME
from Products.PloneSubscription import SubscriptionPermissions
from Products.PloneSubscription.interfaces.ISubscriber import ISubscriber


schema = BaseFolderSchema.copy()

class TemplatesProvider(BaseFolder):
    """Implement subscriber folder for user"""
    
    __implements__ = BaseFolder.__implements__, ISubscriber
    
    portal_type = meta_type = 'TemplatesProvider'
    archetype_name = 'TemplatesProvider'
    immediate_view = 'base_view'
    default_view   = 'base_view'
    global_allow = True
    schema =  schema
    allowed_content_types = ('SubscriptionTemplate',)
    include_default_actions = 0
    security = ClassSecurityInfo()

    actions = (
        {
        'id'            : 'view',
        'name'          : 'View',
        'action'        : 'string:${object_url}/base_view',
        'permissions'   : (SubscriptionPermissions.ManageSubscriptionContent, ),
        'category'      : 'object',
        'visible'       : 1,
        },
        {
        'id'            : 'edit',
        'name'          : 'Edit',
        'action'        : 'string:${object_url}/base_edit',
        'permissions'   : (SubscriptionPermissions.ManageSubscriptionContent, ),
        'category'      : 'object',
        'visible'       : 1,
        },
    )

registerType(TemplatesProvider, PROJECTNAME)