# -*- coding: utf-8 -*-
"""
$Id: schemata.py,v 1.21 2005/10/06 21:07:39 encolpe Exp $
"""

__author__  = ''
__docformat__ = 'restructuredtext'

# Zope imports
from DateTime import DateTime

# CMF imports
from Products.CMFCore.utils import getToolByName
from Products.CMFCore import CMFCorePermissions

# Archetypes import
from Products.Archetypes.public import *

# Products imports
from Products.PloneSubscription import SubscriptionPermissions


# Base Subscribers schema
BaseSubscriberSchema = BaseFolderSchema.copy()

# Base Subcription schema
BaseSubscriptionSchema = BaseSchema.copy() + Schema((
    StringField(
        'rpath',
        required=True,
        searchable=True,
        default='/',
        read_permission=SubscriptionPermissions.ViewSubscriptionContent,
        write_permission=SubscriptionPermissions.EditSubscriptionContent,
        widget=StringWidget(
            visible={ 'view': 'visible', 'edit': 'visible',},
            label="Relative path",
            label_msgid="label_subscription_rpath",
            description="Relative path from plone site root.",
            description_msgid="help_subscription_rpath",
            i18n_domain="plonesubscription",
            ),
        ),
    DateTimeField(
        'last_send',
        required=True,
        searchable=True,
        default=DateTime(),
        read_permission=SubscriptionPermissions.ViewSubscriptionContent,
        write_permission=SubscriptionPermissions.ManageSubscriptionContent,
        widget=CalendarWidget(
            visible={ 'view': 'visible', 'edit': 'hidden',},
            label="Last send datetime",
            label_msgid="label_subscription_last_send",
            description="Last DateTime this subscription was activated.",
            description_msgid="help_subscription_last_send",
            i18n_domain="plonesubscription",
            ),
        ),
    ),)
BaseSubscriptionSchema['id'].widget.visible = { 'view': 'visible', 'edit': 'hidden',}
BaseSubscriptionSchema['title'].widget.visible = { 'view': 'visible', 'edit': 'hidden',}
BaseSubscriptionSchema['description'].widget.visible = { 'view': 'hidden', 'edit': 'hidden',}

# Forms specific schema

FormAddGroupSubscriptionSchema = Schema((
    StringField(
        'groupSubscriber',
        required=True,
        searchable=False,
        default=[],
        multiValued=True,
        vocabulary='getGroupSubscriberVocabulary',
        enforceVocabulary=True,
        read_permission=SubscriptionPermissions.ManageSubscriptionContent,
        write_permission=SubscriptionPermissions.ManageSubscriptionContent,
        widget=MultiSelectionWidget(
            visible={ 'view': 'visible', 'edit': 'visible',},
            label="Grouped subscribers",
            label_msgid="label_grouped_subscriber",
            description="Grouped subcribers available",
            description_msgid="help_grouped_subscriber",
            i18n_domain='plonesubscription',
            ),
        ),
    ),)
